export function TextHighlight({ children: text = "", tags = [], className }) {
  if (!tags?.length) return text;
  const matches = [...text.matchAll(new RegExp(tags.join("|"), "ig"))];
  const startText = text.slice(0, matches[0]?.index);
  return (
    <span>
      {startText}
      {matches.map((match, i) => {
        const startIndex = match?.index;
        const currentText = match[0];
        const endIndex = startIndex + currentText?.length;
        const nextIndex = matches[i + 1]?.index;
        const untilNextText = text.slice(endIndex, nextIndex);
        return (
          <span key={i}>
            <span className={className}>{currentText}</span>
            {untilNextText}
          </span>
        );
      })}
    </span>
  );
}

export default TextHighlight;
